/*
 *
 * (C) Jochen Karrer March 1996
 *
 */


/* Lib ioctls */


case MV1_SET_H_START:
	mv1_set_h_start(arg,bs);	
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV1_INQUIRE_H_START:
	return mv1_inquire_h_start(bs);

case MV1_SET_V_START:
	mv1_set_v_start(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV1_INQUIRE_V_START:
	return mv1_inquire_v_start(bs);

case MV1_SET_H_END:
	mv1_set_h_end(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV1_INQUIRE_H_END:
	return mv1_inquire_h_end(bs);

case MV1_SET_V_END:
	mv1_set_v_end(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV1_INQUIRE_V_END:
	return mv1_inquire_v_end(bs);

case MV1_INQUIRE_CUR_LINE:
	return mv1_inquire_cur_line(bs);

case MV1_SET_EQ_REMOVE:
	mv1_set_eq_remove(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV1_INQUIRE_EQ_REMOVE:
	return mv1_inquire_eq_remove(bs);

/*+++++++++++++++++++++++++++++++++++++++++*/
case MV1_SELECT_PIXELMODE:
	mv1_select_pixel_mode(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_INQUIRE_PIXELMODE:
	return mv1_inquire_pixel_mode(bs);

case MV1_INQUIRE_PIXELBITS:
	return mv1_inquire_pixel_bits(bs);

case MV1_SELECT_TRANSFER_MODE:
	mv1_select_transfer_mode(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;
	
case MV1_SET_CVIDEO_SOURCE:
	mv1_set_cvideo_source(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_INQUIRE_CVIDEO_SOURCE:
	return mv1_inquire_cvideo_source(bs);

case MV1_SET_CSYNC_SOURCE:
	mv1_set_csync_source(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV1_INQUIRE_CSYNC_SOURCE:
	return mv1_inquire_csync_source(bs);

case MV1_SELECT_CLOCK_SOURCE:
	mv1_select_clock_source(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_INQUIRE_CLOCK_SOURCE:
	return mv1_inquire_clock_source(bs);

case MV1_SELECT_SYNC_STRIP_RANGE:
	mv1_select_sync_strip_range(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_INQUIRE_SYNC_STRIP_RANGE:
	return mv1_inquire_sync_strip_range(bs);

/*	
case MV1_SELECT_AD_CONVERTOR:
	mv1_select_ad_convertor(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;
*/
case MV1_SET_SHIFT_DOWN:
	mv1_set_shift_down(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV1_INQUIRE_SHIFT_DOWN:
	return mv1_inquire_shift_down(bs);

case MV1_SET_PLL_PHASE_TRIM:
	mv1_set_pll_phase_trim(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_INQUIRE_PLL_PHASE_TRIM:
	return mv1_inquire_pll_phase_trim(bs);
	

case MV1_RD_VSYNC_INFO:
	return mv1_rd_vsync_info(bs);

case MV1_SET_AD_TOP_LEVEL:
	mv1_set_ad_top_level(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_INQUIRE_AD_TOP_LEVEL:
	return mv1_inquire_ad_top_level(bs);

case MV1_SET_AD_BOTTOM_LEVEL: 
	mv1_set_ad_bottom_level(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_INQUIRE_AD_BOTTOM_LEVEL:
	return mv1_inquire_ad_bottom_level(bs);

/*case MV1_SET_DIGITIZE_LEVEL:*/
	
case MV1_INQUIRE_FIELD:
case MV1_IS_FRAME_END:
	return -EINVAL;

case MV1_SET_CLAMP_LEVEL:
	mv1_set_clamping_level(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_INQUIRE_CLAMP_LEVEL:
	return mv1_inquire_clamping_level(bs);	

case MV1_SELECT_CLAMPING:
	mv1_select_clamping(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_INQUIRE_CLAMPING:
	return mv1_inquire_clamping(bs);
	
case MV1_SET_DIG_CAMERA_CONFIG:
case MV1_SETCOLOR_MODULE_CONFIG:
	return -EINVAL;

case MV1_SET_PLL_PHASE_DETECTOR:
	mv1_set_pll_phase_detector(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_SET_LSEXP_REDUCTION:
case MV1_SET_GAIN:
case MV1_GET_GAIN_RANGE:
	return -EINVAL;

case MV1_INQUIRE_DC_OFFSET:
	return mv1_inquire_dc_offset(bs);

case MV1_SET_DC_OFFSET:
	mv1_set_dc_offset(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV1_GET_OFFSET_RANGE:
case MV1_SET_EXT_TRIGGER:
	mv1_set_ext_trigger(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV1_INQUIRE_EXT_TRIGGER:
	return mv1_inquire_ext_trigger(bs);

case MV1_SET_TRIGGER_POLARITY:
	mv1_set_trigger_polarity(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV1_INQUIRE_TRIGGER_POLARITY:
	return mv1_inquire_trigger_polarity(bs);

case MV1_SET_INTERLACE:
	mv1_set_interlace(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV1_INQUIRE_INTERLACE:
	return mv1_inquire_interlace(bs);

case MV1_WAIT_EXT_TRIGGER:
	return mv1_wait_ext_trigger(arg,bs);


case MV1_WAIT_FRAME_END:
	return mv1_wait_frame_end(bs);

case MV1_WAIT_TRANSFER_END:
	return mv1_wait_transfer_end(bs);

case MV1_SNAP:
	if(arg){
		bs->snap = 1;
		bs->snap_flag = 1;
		while(bs->snap_flag == 1){
                	schedule();
                	if(signal_pending(current))
                        	return -EINTR;
        	}
		return 0;
	}
	else {
		bs->snap = 0;
		bs->snap_flag = 0;
	}
	return 0;

	
case MV1_SET_HOST_MASK:
	mv1_set_host_mask(arg,bs);	
	MV1_SEND_EVENT(bs,cmd); 
	return 0;
	
case MV1_INQUIRE_HOST_MASK:
	return mv1_inquire_host_mask(bs); 

case MV1_SET_GRAB_MASK:
	mv1_set_grab_mask(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_INQUIRE_GRAB_MASK:
	return mv1_inquire_grab_mask(bs);

case MV1_SET_FILTER_CUTOFF:
	mv1_set_filter_cutoff(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_INQUIRE_FILTER_CUTOFF:
	return mv1_inquire_filter_cutoff(bs);


case MV1_SET_HIGH_FREQ_BOOST:
	mv1_set_high_freq_boost(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_INQUIRE_HIGH_FREQ_BOOST:
	return mv1_inquire_high_freq_boost(bs);

case   MV1_SET_GP_BIT0:
		mv1_set_gp_bit0(arg,bs);
		MV1_SEND_EVENT(bs,cmd);
		return 0;

case   MV1_INQUIRE_GP_BIT0:	
		return	mv1_inquire_gp_bit0(bs);
		
case   MV1_SET_GP_BIT1:
		mv1_set_gp_bit1(arg,bs);
		MV1_SEND_EVENT(bs,cmd);
		return 0;

case   MV1_INQUIRE_GP_BIT1:	
		return	mv1_inquire_gp_bit1(bs);

case MV1_SET_LUT_MODE:
	break;

case MV1_SELECT_LUT_BANK:
	mv1_select_lut_bank(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
        return 0;

case MV1_INQUIRE_LUT_BANK:
	return mv1_inquire_lut_bank(bs);

case MV1_LUT_READ:
	return -EINVAL;

case MV1_LUT_WRITE_VALUE:
	{ 
		u_long v1,v2,v3;
		get_user(v1,(u_long*)arg),
        	get_user(v2,((u_long*)arg)+1),
		get_user(v3, ((u_long*)arg)+2),
		mv1_write_lut_value(v1,v2,v3,jiffies+HZ/10,bs);
	}
	return 0; 

case MV1_WRITE_8BIT_LUT:
	{
		u_long val;
		u_long addr;
		u_long lut;
		u_long timeout;

		if(get_user(val,(u_long*)arg))
			return -EFAULT;
		if(get_user(addr,((u_long*)arg)+1)) {
			return -EFAULT;
		}
		if(get_user(lut,((u_long*)arg)+2)) {
			return -EFAULT;
		}

		timeout = jiffies+HZ;
		for(i=0;i<256;i++) {
			unsigned long v1,v2;
			get_user(v1,((unsigned long*)val)+i);
			get_user(v2,((unsigned long *)addr)+i);
        		mv1_write_lut_value(v1,v2,lut,timeout,bs);
			if(current->need_resched)
                        	schedule();

    		}
		if(jiffies >= timeout)
			return -ETIMEDOUT;
		return timeout-jiffies;

	}

	

case MV1_SET_GRABFLAG:
	MV1_SEND_EVENT(bs,cmd);
	return mv1_set_grabflag(arg,bs);

case MV1_INQUIRE_GRABFLAG:
	return mv1_inquire_grabflag(bs);

case MV1_SET_STARTFIELD:
	MV1_SEND_EVENT(bs,cmd);
	return mv1_set_startfield(arg,bs);

case MV1_INQUIRE_STARTFIELD:
	return mv1_inquire_startfield(bs);

case MV1_SET_GRAB:
	MV1_SEND_EVENT(bs,cmd);
	return mv1_set_grab(arg,bs);

case MV1_INQUIRE_GRAB:
	return mv1_inquire_grab(bs);

/* 4.10 Master Mode Transfer and Interrupt Handling */

case    MV1_SET_MASTER_ENABLE:
		if(!bs->tlist_valid) {
			printk("mv1000 enable master ioctl with invalid tlist\n");
		}	
		mv1_set_master_enable(arg,bs);
		MV1_SEND_EVENT(bs,cmd);
		return 0;

case 	MV1_INQUIRE_MASTER_ENABLE:
		return mv1_inquire_master_enable(bs);

case 	MV1_SET_MASTER_LOOP:
		mv1_set_master_loop(arg,bs);
		MV1_SEND_EVENT(bs,cmd);
		return 0;

case    MV1_INQUIRE_MASTER_LOOP:
                return mv1_inquire_master_loop(bs);


case 	MV1_SET_MASTER_WAIT_FRAME:
		mv1_set_master_wait_frame(arg,bs);
		MV1_SEND_EVENT(bs,cmd);
		return 0;

case 	MV1_INQUIRE_MASTER_WAIT_FRAME:
		return mv1_inquire_master_wait_frame(bs);

case    MV1_SET_FRAME_END_IRQ:
	mv1_set_frame_end_irq(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case    MV1_INQUIRE_FRAME_END_IRQ:			
	return mv1_inquire_frame_end_irq(bs);

//	Should this be allowed from User-Space ?
case 	MV1_SET_TRANSFER_END_IRQ:
	mv1_set_transfer_end_irq(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case	MV1_INQUIRE_TRANSFER_END_IRQ:
	return mv1_inquire_transfer_end_irq(bs);

/*	ICS1522 PLL */

case ICS_SET_FBK_DIV:
	ics_set_fbkdiv(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case ICS_INQUIRE_FBK_DIV:
	return ics_inquire_fbkdiv(bs);

case ICS_SET_REF_DIV:
	ics_set_refdiv(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case ICS_INQUIRE_REF_DIV:
	return ics_inquire_refdiv(bs);

case  ICS_SET_REF_POL:
	ics_set_refpol(arg,bs);
        MV1_SEND_EVENT(bs,cmd);
        return 0;

case  ICS_INQUIRE_REF_POL:
	return ics_inquire_refpol(bs);

case  ICS_SET_VCO_GAIN: 
	ics_set_vco_gain(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case  ICS_INQUIRE_VCO_GAIN: 
	return ics_inquire_vco_gain(bs); 

case  ICS_SET_PFD_GAIN: 
	ics_set_pfd_gain(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case  ICS_INQUIRE_PFD_GAIN:
	return ics_inquire_pfd_gain(bs);

case  ICS_SET_PDEN:
	ics_set_pden(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case  ICS_INQUIRE_PDEN:
	return ics_inquire_pden(bs);

case  ICS_SET_CLKSEL:
	ics_set_clksel(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case  ICS_INQUIRE_CLKSEL: 
	return ics_inquire_clksel(bs);

case  ICS_SET_PDA: 
	ics_set_pda(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case  ICS_INQUIRE_PDA:
	return ics_inquire_pda(bs);

case  ICS_SET_PDB:  
	ics_set_pdb(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case  ICS_INQUIRE_PDB:
	return ics_inquire_pdb(bs);

case ICS_SET_LEAD_LAG:
	ics_set_lead_lag(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case ICS_INQUIRE_LEAD_LAG:
	return ics_inquire_lead_lag(bs);

case LM1882_SELECT_SYNC_OUTPUT:
	lm1882_select_sync_output(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case LM1882_INQUIRE_SYNC_OUTPUT:
	return lm1882_inquire_sync_output(bs);

case LM1882_SELECT_EQSERR:
	lm1882_select_eqserr(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case LM1882_INQUIRE_EQSERR:
	return lm1882_inquire_eqserr(bs);

case LM1882_SELECT_VCSYNC_POLARITY:
	lm1882_select_vcsync_pol(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case LM1882_INQUIRE_VCSYNC_POLARITY:
	return lm1882_inquire_vcsync_pol(bs);
	
case LM1882_SELECT_HSYNC_POLARITY:
	lm1882_select_hsync_pol(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case LM1882_INQUIRE_HSYNC_POLARITY:
	return lm1882_inquire_hsync_pol(bs);

case LM1882_SET_PIXEL_PER_LINE:
	lm1882_set_pixel_per_line(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case LM1882_INQUIRE_PIXEL_PER_LINE:
	return lm1882_inquire_pixel_per_line(bs);

case LM1882_SET_LINE_PER_FRAME:
	lm1882_set_line_per_frame(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case LM1882_INQUIRE_LINE_PER_FRAME:
	return lm1882_inquire_line_per_frame(bs);


case MV11_SET_PULSE_MODE: 
	mv11_set_pulse_mode(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_PULSE_MODE:
	return mv11_inquire_pulse_mode(bs);


case MV11_SET_MODE_CONTROL:
	mv11_set_mode_control(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_MODE_CONTROL:
	return mv11_inquire_mode_control(bs);

case MV11_SELECT_PAR_FRAME_REMOVE:
	mv11_select_par_frame_rem(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_PAR_FRAME_REMOVE:
	return mv11_inquire_par_frame_rem(bs);

case MV11_SELECT_CLOCK:
	mv11_select_clock(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_CLOCK:
	return mv11_inquire_clock(bs);

case MV11_SET_BYPASS_COUNTER:
	mv11_set_bypass_counter(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_BYPASS_COUNTER:
	return mv11_inquire_bypass_counter(bs);

case MV11_SELECT_CAMERA_DRIVE:
	mv11_select_camera_drive(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_CAMERA_DRIVE:
	return mv11_inquire_camera_drive(bs);
	
case MV11_SET_COUNTER:
	mv11_set_counter(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_COUNTER:
	return mv11_inquire_counter(bs);	
	
case MV11_SET_TRIG_ENABLE:
	mv11_set_trig_enable(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_TRIG_ENABLE:
	return mv11_inquire_trig_enable(bs);

case MV11_SET_TRIG_POL:
	mv11_set_trig_pol(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_TRIG_POL:
	return mv11_inquire_trig_pol(bs);

case MV11_SET_LS_EXP:
	mv11_set_ls_exp(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_LS_EXP:
	return mv11_inquire_ls_exp(bs);

case MV11_SET_LDV_POL:
	mv11_set_ldv_pol(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_LDV_POL:
	return mv11_inquire_ldv_pol(bs);

case MV11_SET_FDV_POL:
	mv11_set_fdv_pol(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_FDV_POL:
	return mv11_inquire_fdv_pol(bs);
	
case MV11_SET_PCLK_POL:
	mv11_set_pclk_pol(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV11_INQUIRE_PCLK_POL:
	return mv11_inquire_pclk_pol(bs);

case MV1_SET_TOP_SC:
	mv1_set_top_sc(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case MV1_INQUIRE_TOP_SC:
	return mv1_inquire_top_sc(bs);	

case TEST1:
	return mv1_is_offscreen(bs);
case TEST2:
	return test2_ioctl(arg,bs);

case TEST2_GET:
	return test2_get_ioctl(bs);

/* 	My own extensions */

case MV1_SET_INTEGRATION_TIME:
	mv1_set_integration_time(arg,bs);
	MV1_SEND_EVENT(bs,cmd); 
	return 0;

case MV1_RESET_INTEGRATION_TIME:
	mv1_reset_integration_time(bs);
	return 0;

case MV1_INQUIRE_INTEGRATION_TIME:
	return mv1_inquire_integration_time(bs);

case MV1_INQUIRE_GRAB_ADR_OFFSETS:
                put_user(bs->curr_gw.f_start-bs->vvmem,(u_long *)arg);
                put_user(bs->curr_gw.s_start-bs->vvmem,((u_long *)arg)+1);
                return 0;

case CAM_SET_INT_CTL_MODE: 
	cam_set_int_ctl_mode(arg,bs);
	MV1_SEND_EVENT(bs,cmd);
	return 0;

case CAM_INQUIRE_INT_CTL_MODE:
	return cam_inquire_int_ctl_mode(bs);

case FG_INQUIRE_REST_TIME:
	return fg_inquire_rest_time(bs);

case MV1_INQUIRE_MACHINE_STATE:
	return jiffies - bs->last_interrupt;

case MV1_INQUIRE_FRAME_END_COUNT:
	return bs->frame_int_count;

case MV1_INQUIRE_BAD_LIST_COUNT:
	return bs->bad_list_count;

case MV1_INQUIRE_TRANSFER_END_COUNT:
	return bs->transfer_end_count;

